#include <mega8.h>

#include <delay.h>

// Alphanumeric LCD functions
#include <alcd.h>

//*************************************************************************** 
typedef unsigned char byte; //     
 //         
 
     flash byte char0[8]={ 
     0b0000000, 
     0b0001110, 
     0b0010001, 
     0b0010001, 
     0b0010001,             //      ()
     0b0001010, 
     0b0011011, 
     0b0000000}; 
 
   void define_char(byte flash *pc,byte char_code) //       
     { 
     byte i,a; 
     a=(char_code<<3)|0x40; 
     for (i=0; i<8; i++) lcd_write_byte(a++,*pc++); 
     } 
//****************************************************************************  
//****************************************************************************
  int Okr(float a)   //      float  int
    {      
    float ao;
    ao = a - (int)a;
    if (ao >= 0.5) a = (int)(a+1);
     else a = a - ao;
    return  a;   
    }  
//******************************************************************************
    
#define N 4.0                  //   

//******************************************************************************
  float Ssr (float a, int b)   //    
    { 
    a= (a * (N-1) + b) / N;   
    return a;
    } 
//****************************************************************************** 

   
#define FIRST_ADC_INPUT 0
#define LAST_ADC_INPUT 5
unsigned int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];
#define ADC_VREF_TYPE 0xC0     //   2,56 

// ADC interrupt service routine
// with auto input scanning
interrupt [ADC_INT] void adc_isr(void)
{
static unsigned char input_index=0;
// Read the AD conversion result
adc_data[input_index]=ADCW;
// Select next ADC input
if (++input_index > (LAST_ADC_INPUT-FIRST_ADC_INPUT))
   input_index=0;
ADMUX=(FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff))+input_index;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
}

// Declare your global variables here
  eeprom unsigned int  e_ustl, e_ustr;

     // e_ustl              eeprom
     // e_ustr             eeprom
     
void main(void)
{
// Declare your local variables here
unsigned char chanel=0, x, y,  Ts,St,Ds,Ed, ps,uk, com=0, a=0, aa=0, kanal;
    
    //  chanel         ADC   adc_data[]
    //  N              
    //  x, y            LCD 
    //  Ts,St,Ds,Ed  ,   .. 
    //  ps                (V, A, O, K)
    //  uk             (<  >)
    //  com          
    //  a               
    //  aa                   
    //  kanal                 (L  R)
    
unsigned int ustl=0,ustr=0, c, del ;
    
    //   ustl          
    //   ustr          
    //                     
    //  del                 

unsigned long int REZ=0, vyvod;

    //   REZ             LCD
    //   vyvod           
        
float   Vl, Vr, Al, Ar, adc_Vl=adc_data[0], adc_Vr=adc_data[2],    
                        adc_Al=adc_data[1], adc_Ar=adc_data[3];
                        
    //   Vl           
    //   Vr           
    //   Al           
    //   Ar            
    //  adc_Vl        ADC    
    //  adc_Vr        ADC    
    //  adc_Al        ADC    
    //  adc_Ar        ADC    
    
bit button_pressed0=0, button_pressed1=0, razr_ust_l=0, razr_ust_r=0; 
 
//unsigned char flag_bit;
   
   // button_pressed0 = flag_bit.0    
   // button_pressed1 = flag_bit.1    
   //   razr_ust_l  = flag_bit.2          
   //   razr_ust_r  = flag_bit.3          
   
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=1 State4=1 State3=P State2=P State1=P State0=P 
PORTD=0x3F;
DDRD=0x30;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
ADMUX=FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff);
ADCSRA=0xCD;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// Alphanumeric LCD initialization
// Connections are specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTB Bit 0
// RD - PORTB Bit 1
// EN - PORTB Bit 2
// D4 - PORTB Bit 4
// D5 - PORTB Bit 5
// D6 - PORTB Bit 6
// D7 - PORTB Bit 7
// Characters/line: 16

//**********************************************************************
 lcd_init(16); //  
  //   char0   000 define_char(char0,0); 
     define_char(char0,0);
 lcd_clear(); //   
//*********************************************************************** 

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here
       
      //     EEPROM         
            
       if (ustl != e_ustl && razr_ust_l == 0 && razr_ust_r == 0) ustl = e_ustl;   
       if (ustr != e_ustr && razr_ust_l == 0 && razr_ust_r == 0) ustr = e_ustr;   
       
        chanel++;                     //   adc_data[]
        if (chanel>5) { chanel=0;}    //    4  5  , 
             
        //////////////////////////////////////////////////////////////////
                     
                        //        30B max
        if (chanel==0) 
        {            
           adc_Vl= Ssr(adc_Vl, adc_data[0]);     //                            
             Vl= (float)adc_Vl * 1.0 * 2560.0 / 1023;         
         REZ = Okr(Vl);                                      
         x=0;        //  
         y=0;        //    LCD    
         ps=0x56;    //     V
        }
                                    
                  //         2A max
        if (chanel==1 &&  razr_ust_l == 0)     //      
        {                                      //    
            adc_Al=Ssr(adc_Al, adc_data[1]);   //        
             Al= (float)adc_Al *256.0/1023;           
         REZ = Okr(Al);     
         x=0;
         y=1;               
         ps=0x41;   //     A
        } 
         
                 if  (Okr(Al) >= ustl)   PORTD.4 = 0;  //    
         
         ////////////////////////////////////////////////////////////////////
                           //       30B max
        if (chanel==2) 
        {               
           adc_Vr = Ssr(adc_Vr, adc_data[2]);         
            Vr=  (float)adc_Vr * 1.0 * 2560.0/1023;    
         REZ = Okr(Vr);      
         x=10;
         y=0;            
         ps=0x56;
        }        
                            //       2A max   
        if (chanel==3 &&  razr_ust_r == 0)      //                                                 
        {                                       //    
            adc_Ar = Ssr(adc_Ar, adc_data[3]);         
             Ar= (float)adc_Ar *256.0/1023;
          REZ = Okr(Ar);      
          x=10;
          y=1;
          ps=0x41;            
        } 
         
             if  (Okr(Ar) >= ustr)   PORTD.5 = 0;       //    
             
//             
//         if (chanel==4 && PIND.0 == 0 && PIND.2 == 0) {   //   ADC
//         
//         }   
//             
//         if (chanel==5 && PIND.1 == 0 && PIND.3 == 0) {
//         
//         }   
//         
         ///////////////////////////////////////////////////////////////
                       //   D0  D1
             if (PIND.0 == 0  && button_pressed0 == 0 ){ //   1 
                delay_ms(1);                             //   
                button_pressed0 = 1;                     //  
                //kanal=(0x4c);                            //     (L)
            };
            
             if (PIND.0 == 1) button_pressed0 = 0;  //    
             
             
            
             if (PIND.1  == 0 && button_pressed1 == 0){ //   2 
                delay_ms(1);                            //   
                button_pressed1 = 1;                    //  
                //kanal=(0x52);                           //      (R)
            };
            
            if (PIND.1 == 1) button_pressed1 = 0;  //    
                       
          //////////   
                   if (PIND.0==1 && PIND.1==1) {kanal=0x80;}      
                         //     (L)
             if (button_pressed0 == 1 && chanel==2 && (int)Al > 0){ 
                                          
                float W;
                
                W = (float)(Vl*Al)/100.0;          //   Left  
                REZ = Okr(W);
                ps=0x57;                             //   W               
            }
             
            
              if (button_pressed0 == 1 && chanel==3){ 
                  if ((int)Al > 0)
                  {                         
                         float om;
                        kanal=(0x4c);                            //   (L)
                            om = (float)100.0*Vl/Al;             //  Left
                         
                           if (om>=100000){
                              REZ = Okr(om / 1000);
                              ps=0x4b;                 // kO K  
                             }
                              
                           else {
                             REZ = Okr(om);
                             ps=0x0;                  //   
                           }     
                           
                  }
                  else  kanal=(0x21);         // !                   
                
            } 
            
                
                        //      (R)  
             if (button_pressed1 == 1 && chanel==0 && (int)Ar > 0){ 
                  float W;                           
                                
                W = (float)(Vr*Ar)/100.0;           //   Right
                REZ = Okr(W);
                ps=0x57;                              //   W
                                 
            };
            
            
             if (button_pressed1 == 1 && chanel == 1){
                if ((int)Ar > 0)
                 {
                    float om;
                        kanal=(0x52);                    // (R)       
                    om = (float)100.0*Vr/Ar;             //  Right
                     
                       if (om>=100000){
                          REZ = Okr(om / 1000);
                          ps=0x4b;                 // kO K  
                         }
                          
                       else {
                         REZ = Okr(om);
                         ps=0x0;                  //  ( )
                       }                                     
                  }
                  else  kanal=(0x21);            // !
                       
            };
            
              
            
                   
             
           ////////////////////////////////////////////////////////////////////////// 
           //          2.5A max
           
           if (PIND.2  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.3 == 1){delay_ms(20);} //   3
                
         if (PIND.2  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.3 == 1){
                                          
            
             
             a++;              
             x = 0;
             y = 1;
             REZ = ustl;              //   
             ps = 0x41;
             uk = 0x3c;
             
                if (a >= 50) razr_ust_l = 1;     //              
         }
            
         
                    
            if (PIND.2  == 0 && razr_ust_l == 1 && razr_ust_r == 0 && PIND.3 == 1) {
              
             
               
             del = 300;                    //    
             aa++; 
                                          
               if (aa > 8) del = 50;        //                          
                                              
                                      //  
                    ++ustl;
                    
                 if (ustl > 250) {ustl = 0;}      //   0
                     x = 0;
                     y = 1;         
                     REZ = ustl; 
                     ps = 0x41;
                     uk = 0xc8;                // 0x3c;
                     delay_ms(del);
                            
                          
            } 
            
                  
            
            if (PIND.3  == 0 && razr_ust_l == 1 && razr_ust_r == 0 && PIND.2 == 1) {
               
             del = 300;
             aa++; 
             
               if (aa > 8) del = 50;
               
                  if (ustl > 0){      //   
                                                                          
                   --ustl;             //  
                                                
                  if (ustl <= 0) {ustl=250;}
                     x = 0;
                     y = 1;         
                     REZ = ustl;     
                     ps = 0x41;
                     uk = 0xc8;                 //      0x3c;
                     delay_ms(del);
                }             
                          
            } 
             

            //////////////////////////////////////////////////////////////////////////

            ////////////////////////////////////////////////////////////////////////// 
            ///         2.5A max
           
           if (PIND.3  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.2 == 1){delay_ms(20);} //   3
                
         if (PIND.3  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.2 == 1){
                                         
             a++;              
             x=10;
             y=1;
             REZ=ustr;              //   
             ps=0x41;
             uk=0x3e;
             
                if (a >= 50)  razr_ust_r = 1;     //    
         }   
         
        
           
            if (PIND.3  == 0 && razr_ust_l == 0 && razr_ust_r == 1 && PIND.2 == 1) {
             
             del = 300;
             aa++; 
             
               if (aa > 10) del = 50;                             
                                              
             ++ustr;                         //  
             
                 if (ustr>250) {ustr=0;}
                     x = 10;
                     y = 1;         
                     REZ = ustr;
                     ps = 0x41;
                     uk = 0xc9;             //   0x3e;
                     delay_ms(del); 
                            
                         
            } 
            
                  
            
            if (PIND.2  == 0 && razr_ust_l == 0 && razr_ust_r == 1 && PIND.3 == 1) {
             
             del = 300;
             aa++; 
             
               if (aa > 10) del = 50;
               
                  if (ustr > 0){                     //            
                     
                     --ustr;                         //  

                  if (ustr <= 0) {ustr=250;}
                     x = 10;
                     y = 1;         
                     REZ = ustr;
                     ps = 0x41;
                     uk = 0xc9;                     //  0x3e;
                     delay_ms(del);
                }             
                          
            } 
               //   <  >   
       
        if (PIND.3 == 1 && PIND.2  == 1 && razr_ust_l == 0 && razr_ust_r == 0)  uk = 0x80;     
       
        if (PIND.3 == 1 && PIND.2  == 1)  a = 0; //   
                         
         //////////////////////////////////////////////////////////////////////////   
                  
                       //        
         
              if (PIND.2==1 && PIND.3==1 && (razr_ust_l == 1 | razr_ust_r == 1)) aa = 0;                                                              
                               
             //           3  4
             
                 if (PIND.2==0 || PIND.3==0) c = 0;  //     
                                                     // 
               c++;                   // 
                
                if (c >= 300)         //   
                {                              
                   uk = 0x80;         //   <  >
                   razr_ust_l = 0;    //   
                   razr_ust_r = 0;    //   
                       
                   if (e_ustl != ustl)  e_ustl = ustl;    //     EEPROM    
                   if (e_ustr != ustr)  e_ustr = ustr;    //    EEPROM   
                   
                   c = 0; 
                }
             
             
       /////////////////////////////////////////////////////////////////////////////////     
        
          
       //----------------    
          if (REZ>9999) {
          vyvod=REZ/10;       // /10
          com=1;
          }    
          
          if (REZ<10000 && REZ>99){
          vyvod=REZ;
          com=2;
          }
          
          if (REZ<100) {
          vyvod=REZ;         
          com=2;                
          }
       
              
       
            Ts=(vyvod/1000)%10;     //                                      
              
            St=(vyvod/100)%10;      //                                  
                                 
            Ds=(vyvod/10)%10;       //                                
               
            Ed=(vyvod/1)%10;        //   
       
       //-----------------   LCD   
                     
                lcd_gotoxy(x,y);
                
       if (REZ>9999 )   lcd_putchar(0x80);     //                        
       if (REZ >=1000)  lcd_putchar(Ts+0x30);                   
                        lcd_putchar(St+0x30);  
       if (REZ<9999 )   lcd_putchar(',');         
                        lcd_putchar(Ds+0x30);               
       if (REZ < 1000)  lcd_putchar(Ed+0x30);         
                        lcd_putchar(ps);
                          
                lcd_gotoxy(7,1);
            lcd_putchar(uk);
                lcd_gotoxy(7,0);
            lcd_putchar(kanal);       
            delay_ms(10);

             com=0;

     }     //while(1)

}    //main