
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 4,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF __lcd_x=R5
	.DEF __lcd_y=R4
	.DEF __lcd_maxx=R7

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _adc_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_char0:
	.DB  0x0,0xE,0x11,0x11,0x11,0xA,0x1B,0x0

_0x9:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
_0x2000003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;
;// Alphanumeric LCD functions
;#include <alcd.h>
;
;//***************************************************************************
;typedef unsigned char byte; //     
; //        
;
;     flash byte char0[8]={
;     0b0000000,
;     0b0001110,
;     0b0010001,
;     0b0010001,
;     0b0010001,             //      ()
;     0b0001010,
;     0b0011011,
;     0b0000000};
;
;   void define_char(byte flash *pc,byte char_code) //      
; 0000 0017      {

	.CSEG
_define_char:
; 0000 0018      byte i,a;
; 0000 0019      a=(char_code<<3)|0x40;
	ST   -Y,R26
	RCALL __SAVELOCR2
;	*pc -> Y+3
;	char_code -> Y+2
;	i -> R17
;	a -> R16
	LDD  R30,Y+2
	LSL  R30
	LSL  R30
	LSL  R30
	ORI  R30,0x40
	MOV  R16,R30
; 0000 001A      for (i=0; i<8; i++) lcd_write_byte(a++,*pc++);
	LDI  R17,LOW(0)
_0x4:
	CPI  R17,8
	BRSH _0x5
	ST   -Y,R16
	INC  R16
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	SBIW R30,1
	LPM  R26,Z
	RCALL _lcd_write_byte
	SUBI R17,-1
	RJMP _0x4
_0x5:
; 0000 001B }
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
;//****************************************************************************
;//****************************************************************************
;  int Okr(float a)   //      float  int
; 0000 001F     {
_Okr:
; 0000 0020     float ao;
; 0000 0021     ao = a - (int)a;
	RCALL __PUTPARD2
	SBIW R28,4
;	a -> Y+4
;	ao -> Y+0
	RCALL SUBOPT_0x0
	RCALL __CFD1
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x3
; 0000 0022     if (ao >= 0.5) a = (int)(a+1);
	RCALL SUBOPT_0x4
	__GETD1N 0x3F000000
	RCALL __CMPF12
	BRLO _0x6
	RCALL SUBOPT_0x0
	__GETD2N 0x3F800000
	RCALL __ADDF12
	RCALL __CFD1
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x2
	RJMP _0x7E
; 0000 0023      else a = a - ao;
_0x6:
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x0
	RCALL __SUBF12
_0x7E:
	__PUTD1S 4
; 0000 0024     return  a;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RCALL __CFD1
	ADIW R28,8
	RET
; 0000 0025     }
;//******************************************************************************
;
;#define N 4.0                  //   
;
;//******************************************************************************
;  float Ssr (float a, int b)   //    
; 0000 002C     {
_Ssr:
; 0000 002D     a= (a * (N-1) + b) / N;
	ST   -Y,R27
	ST   -Y,R26
;	a -> Y+2
;	b -> Y+0
	__GETD2S 2
	__GETD1N 0x40400000
	RCALL SUBOPT_0x6
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x2
	RCALL __ADDF12
	RCALL SUBOPT_0x7
	__GETD1N 0x40800000
	RCALL __DIVF21
	__PUTD1S 2
; 0000 002E     return a;
	ADIW R28,6
	RET
; 0000 002F     }
;//******************************************************************************
;
;
;#define FIRST_ADC_INPUT 0
;#define LAST_ADC_INPUT 5
;unsigned int adc_data[LAST_ADC_INPUT-FIRST_ADC_INPUT+1];
;#define ADC_VREF_TYPE 0xC0     //   2,56
;
;// ADC interrupt service routine
;// with auto input scanning
;interrupt [ADC_INT] void adc_isr(void)
; 0000 003B {
_adc_isr:
	ST   -Y,R24
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 003C static unsigned char input_index=0;
; 0000 003D // Read the AD conversion result
; 0000 003E adc_data[input_index]=ADCW;
	LDS  R30,_input_index_S0000003000
	LDI  R26,LOW(_adc_data)
	LDI  R27,HIGH(_adc_data)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	IN   R30,0x4
	IN   R31,0x4+1
	ST   X+,R30
	ST   X,R31
; 0000 003F // Select next ADC input
; 0000 0040 if (++input_index > (LAST_ADC_INPUT-FIRST_ADC_INPUT))
	LDS  R26,_input_index_S0000003000
	SUBI R26,-LOW(1)
	STS  _input_index_S0000003000,R26
	CPI  R26,LOW(0x6)
	BRLO _0x8
; 0000 0041    input_index=0;
	LDI  R30,LOW(0)
	STS  _input_index_S0000003000,R30
; 0000 0042 ADMUX=(FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff))+input_index;
_0x8:
	LDS  R30,_input_index_S0000003000
	SUBI R30,-LOW(192)
	OUT  0x7,R30
; 0000 0043 // Delay needed for the stabilization of the ADC input voltage
; 0000 0044 delay_us(10);
	__DELAY_USB 13
; 0000 0045 // Start the AD conversion
; 0000 0046 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0047 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R24,Y+
	RETI
;
;// Declare your global variables here
;  eeprom unsigned int  e_ustl, e_ustr;
;
;     // e_ustl              eeprom
;     // e_ustr             eeprom
;
;void main(void)
; 0000 0050 {
_main:
; 0000 0051 // Declare your local variables here
; 0000 0052 unsigned char chanel=0, x, y,  Ts,St,Ds,Ed, ps,uk, com=0, a=0, aa=0, kanal;
; 0000 0053 
; 0000 0054     //  chanel         ADC   adc_data[]
; 0000 0055     //  N              
; 0000 0056     //  x, y            LCD
; 0000 0057     //  Ts,St,Ds,Ed  ,   ..
; 0000 0058     //  ps                (V, A, O, K)
; 0000 0059     //  uk             (<  >)
; 0000 005A     //  com          
; 0000 005B     //  a               
; 0000 005C     //  aa               
; 0000 005D     //  kanal                 (L  R)
; 0000 005E 
; 0000 005F unsigned int ustl=0,ustr=0, c, del ;
; 0000 0060 
; 0000 0061     //   ustl          
; 0000 0062     //   ustr          
; 0000 0063     //                 
; 0000 0064     //  del                
; 0000 0065 
; 0000 0066 unsigned long int REZ=0, vyvod;
; 0000 0067 
; 0000 0068     //   REZ             LCD
; 0000 0069     //   vyvod           
; 0000 006A 
; 0000 006B float   Vl, Vr, Al, Ar, adc_Vl=adc_data[0], adc_Vr=adc_data[2],
; 0000 006C                         adc_Al=adc_data[1], adc_Ar=adc_data[3];
; 0000 006D 
; 0000 006E     //   Vl           
; 0000 006F     //   Vr           
; 0000 0070     //   Al           
; 0000 0071     //   Ar           
; 0000 0072     //  adc_Vl        ADC    
; 0000 0073     //  adc_Vr        ADC    
; 0000 0074     //  adc_Al        ADC    
; 0000 0075     //  adc_Ar        ADC    
; 0000 0076 
; 0000 0077 bit button_pressed0=0, button_pressed1=0, razr_ust_l=0, razr_ust_r=0;
; 0000 0078 
; 0000 0079 //unsigned char flag_bit;
; 0000 007A 
; 0000 007B    // button_pressed0 = flag_bit.0    
; 0000 007C    // button_pressed1 = flag_bit.1    
; 0000 007D    //   razr_ust_l  = flag_bit.2          
; 0000 007E    //   razr_ust_r  = flag_bit.3          
; 0000 007F 
; 0000 0080 // Input/Output Ports initialization
; 0000 0081 // Port B initialization
; 0000 0082 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0083 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0084 PORTB=0x00;
	SBIW R28,55
	LDI  R24,16
	LDI  R26,LOW(36)
	LDI  R27,HIGH(36)
	LDI  R30,LOW(_0x9*2)
	LDI  R31,HIGH(_0x9*2)
	RCALL __INITLOCB
;	chanel -> R17
;	x -> R16
;	y -> R19
;	Ts -> R18
;	St -> R21
;	Ds -> R20
;	Ed -> Y+54
;	ps -> Y+53
;	uk -> Y+52
;	com -> Y+51
;	a -> Y+50
;	aa -> Y+49
;	kanal -> Y+48
;	ustl -> Y+46
;	ustr -> Y+44
;	c -> Y+42
;	del -> Y+40
;	REZ -> Y+36
;	vyvod -> Y+32
;	Vl -> Y+28
;	Vr -> Y+24
;	Al -> Y+20
;	Ar -> Y+16
;	adc_Vl -> Y+12
;	adc_Vr -> Y+8
;	adc_Al -> Y+4
;	adc_Ar -> Y+0
;	button_pressed0 -> R15.0
;	button_pressed1 -> R15.1
;	razr_ust_l -> R15.2
;	razr_ust_r -> R15.3
	CLR  R15
	LDI  R17,0
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	__GETW1MN _adc_data,4
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xA
	__GETW1MN _adc_data,2
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xB
	__GETW1MN _adc_data,6
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0085 DDRB=0x00;
	OUT  0x17,R30
; 0000 0086 
; 0000 0087 // Port C initialization
; 0000 0088 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0089 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 008A PORTC=0x00;
	OUT  0x15,R30
; 0000 008B DDRC=0x00;
	OUT  0x14,R30
; 0000 008C 
; 0000 008D // Port D initialization
; 0000 008E // Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 008F // State7=T State6=T State5=1 State4=1 State3=P State2=P State1=P State0=P
; 0000 0090 PORTD=0x3F;
	LDI  R30,LOW(63)
	OUT  0x12,R30
; 0000 0091 DDRD=0x30;
	LDI  R30,LOW(48)
	OUT  0x11,R30
; 0000 0092 
; 0000 0093 // Timer/Counter 0 initialization
; 0000 0094 // Clock source: System Clock
; 0000 0095 // Clock value: Timer 0 Stopped
; 0000 0096 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0097 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0098 
; 0000 0099 // Timer/Counter 1 initialization
; 0000 009A // Clock source: System Clock
; 0000 009B // Clock value: Timer1 Stopped
; 0000 009C // Mode: Normal top=0xFFFF
; 0000 009D // OC1A output: Discon.
; 0000 009E // OC1B output: Discon.
; 0000 009F // Noise Canceler: Off
; 0000 00A0 // Input Capture on Falling Edge
; 0000 00A1 // Timer1 Overflow Interrupt: Off
; 0000 00A2 // Input Capture Interrupt: Off
; 0000 00A3 // Compare A Match Interrupt: Off
; 0000 00A4 // Compare B Match Interrupt: Off
; 0000 00A5 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00A6 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00A7 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00A8 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00A9 ICR1H=0x00;
	OUT  0x27,R30
; 0000 00AA ICR1L=0x00;
	OUT  0x26,R30
; 0000 00AB OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00AC OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00AD OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00AE OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00AF 
; 0000 00B0 // Timer/Counter 2 initialization
; 0000 00B1 // Clock source: System Clock
; 0000 00B2 // Clock value: Timer2 Stopped
; 0000 00B3 // Mode: Normal top=0xFF
; 0000 00B4 // OC2 output: Disconnected
; 0000 00B5 ASSR=0x00;
	OUT  0x22,R30
; 0000 00B6 TCCR2=0x00;
	OUT  0x25,R30
; 0000 00B7 TCNT2=0x00;
	OUT  0x24,R30
; 0000 00B8 OCR2=0x00;
	OUT  0x23,R30
; 0000 00B9 
; 0000 00BA // External Interrupt(s) initialization
; 0000 00BB // INT0: Off
; 0000 00BC // INT1: Off
; 0000 00BD MCUCR=0x00;
	OUT  0x35,R30
; 0000 00BE 
; 0000 00BF // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00C0 TIMSK=0x00;
	OUT  0x39,R30
; 0000 00C1 
; 0000 00C2 // USART initialization
; 0000 00C3 // USART disabled
; 0000 00C4 UCSRB=0x00;
	OUT  0xA,R30
; 0000 00C5 
; 0000 00C6 // Analog Comparator initialization
; 0000 00C7 // Analog Comparator: Off
; 0000 00C8 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00C9 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00CA SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00CB 
; 0000 00CC // ADC initialization
; 0000 00CD // ADC Clock frequency: 125,000 kHz
; 0000 00CE // ADC Voltage Reference: Int., cap. on AREF
; 0000 00CF ADMUX=FIRST_ADC_INPUT | (ADC_VREF_TYPE & 0xff);
	LDI  R30,LOW(192)
	OUT  0x7,R30
; 0000 00D0 ADCSRA=0xCD;
	LDI  R30,LOW(205)
	OUT  0x6,R30
; 0000 00D1 
; 0000 00D2 // SPI initialization
; 0000 00D3 // SPI disabled
; 0000 00D4 SPCR=0x00;
	LDI  R30,LOW(0)
	OUT  0xD,R30
; 0000 00D5 
; 0000 00D6 // TWI initialization
; 0000 00D7 // TWI disabled
; 0000 00D8 TWCR=0x00;
	OUT  0x36,R30
; 0000 00D9 
; 0000 00DA // Alphanumeric LCD initialization
; 0000 00DB // Connections are specified in the
; 0000 00DC // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 00DD // RS - PORTB Bit 0
; 0000 00DE // RD - PORTB Bit 1
; 0000 00DF // EN - PORTB Bit 2
; 0000 00E0 // D4 - PORTB Bit 4
; 0000 00E1 // D5 - PORTB Bit 5
; 0000 00E2 // D6 - PORTB Bit 6
; 0000 00E3 // D7 - PORTB Bit 7
; 0000 00E4 // Characters/line: 16
; 0000 00E5 
; 0000 00E6 //**********************************************************************
; 0000 00E7  lcd_init(16); //  
	LDI  R26,LOW(16)
	RCALL _lcd_init
; 0000 00E8   //   char0   000 define_char(char0,0);
; 0000 00E9      define_char(char0,0);
	LDI  R30,LOW(_char0*2)
	LDI  R31,HIGH(_char0*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _define_char
; 0000 00EA  lcd_clear(); //  
	RCALL _lcd_clear
; 0000 00EB //***********************************************************************
; 0000 00EC 
; 0000 00ED // Global enable interrupts
; 0000 00EE #asm("sei")
	sei
; 0000 00EF 
; 0000 00F0 while (1)
_0xA:
; 0000 00F1       {
; 0000 00F2       // Place your code here
; 0000 00F3 
; 0000 00F4       //     EEPROM         
; 0000 00F5 
; 0000 00F6        if (ustl != e_ustl && razr_ust_l == 0 && razr_ust_r == 0) ustl = e_ustl;
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	BREQ _0xE
	RCALL SUBOPT_0xF
	BRNE _0xE
	RCALL SUBOPT_0x10
	BREQ _0xF
_0xE:
	RJMP _0xD
_0xF:
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x11
; 0000 00F7        if (ustr != e_ustr && razr_ust_l == 0 && razr_ust_r == 0) ustr = e_ustr;
_0xD:
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0xE
	BREQ _0x11
	RCALL SUBOPT_0xF
	BRNE _0x11
	RCALL SUBOPT_0x10
	BREQ _0x12
_0x11:
	RJMP _0x10
_0x12:
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x14
; 0000 00F8 
; 0000 00F9         chanel++;                     //   adc_data[]
_0x10:
	SUBI R17,-1
; 0000 00FA         if (chanel>5) { chanel=0;}    //    4  5  , 
	CPI  R17,6
	BRLO _0x13
	LDI  R17,LOW(0)
; 0000 00FB 
; 0000 00FC         //////////////////////////////////////////////////////////////////
; 0000 00FD 
; 0000 00FE                         //        30B max
; 0000 00FF         if (chanel==0)
_0x13:
	CPI  R17,0
	BRNE _0x14
; 0000 0100         {
; 0000 0101            adc_Vl= Ssr(adc_Vl, adc_data[0]);     //  
	__GETD1S 12
	RCALL __PUTPARD1
	LDS  R26,_adc_data
	LDS  R27,_adc_data+1
	RCALL _Ssr
	RCALL SUBOPT_0x9
; 0000 0102              Vl= (float)adc_Vl * 1.0 * 2560.0 / 1023;
	__GETD2S 12
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	__PUTD1S 28
; 0000 0103          REZ = Okr(Vl);
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
; 0000 0104          x=0;        // 
; 0000 0105          y=0;        //    LCD
	LDI  R19,LOW(0)
; 0000 0106          ps=0x56;    //     V
	LDI  R30,LOW(86)
	STD  Y+53,R30
; 0000 0107         }
; 0000 0108 
; 0000 0109                   //         2A max
; 0000 010A         if (chanel==1 &&  razr_ust_l == 0)     //    
_0x14:
	CPI  R17,1
	BRNE _0x16
	RCALL SUBOPT_0xF
	BREQ _0x17
_0x16:
	RJMP _0x15
_0x17:
; 0000 010B         {                                      //    
; 0000 010C             adc_Al=Ssr(adc_Al, adc_data[1]);   //  
	RCALL SUBOPT_0x0
	RCALL __PUTPARD1
	__GETW2MN _adc_data,2
	RCALL _Ssr
	RCALL SUBOPT_0xB
; 0000 010D              Al= (float)adc_Al *256.0/1023;
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	__PUTD1S 20
; 0000 010E          REZ = Okr(Al);
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x18
; 0000 010F          x=0;
; 0000 0110          y=1;
	LDI  R19,LOW(1)
; 0000 0111          ps=0x41;   //     A
	RCALL SUBOPT_0x1B
; 0000 0112         }
; 0000 0113 
; 0000 0114                  if  (Okr(Al) >= ustl)   PORTD.4 = 0;  //    
_0x15:
	RCALL SUBOPT_0x1A
	RCALL _Okr
	MOVW R26,R30
	RCALL SUBOPT_0x1C
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x18
	CBI  0x12,4
; 0000 0115 
; 0000 0116          ////////////////////////////////////////////////////////////////////
; 0000 0117                            //       30B max
; 0000 0118         if (chanel==2)
_0x18:
	CPI  R17,2
	BRNE _0x1B
; 0000 0119         {
; 0000 011A            adc_Vr = Ssr(adc_Vr, adc_data[2]);
	__GETD1S 8
	RCALL __PUTPARD1
	__GETW2MN _adc_data,4
	RCALL _Ssr
	RCALL SUBOPT_0xA
; 0000 011B             Vr=  (float)adc_Vr * 1.0 * 2560.0/1023;
	__GETD2S 8
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
	__PUTD1S 24
; 0000 011C          REZ = Okr(Vr);
	__GETD2S 24
	RCALL SUBOPT_0x1D
; 0000 011D          x=10;
; 0000 011E          y=0;
	LDI  R19,LOW(0)
; 0000 011F          ps=0x56;
	LDI  R30,LOW(86)
	STD  Y+53,R30
; 0000 0120         }
; 0000 0121                             //       2A max
; 0000 0122         if (chanel==3 &&  razr_ust_r == 0)      //    
_0x1B:
	CPI  R17,3
	BRNE _0x1D
	RCALL SUBOPT_0x10
	BREQ _0x1E
_0x1D:
	RJMP _0x1C
_0x1E:
; 0000 0123         {                                       //    
; 0000 0124             adc_Ar = Ssr(adc_Ar, adc_data[3]);
	RCALL __GETD1S0
	RCALL __PUTPARD1
	__GETW2MN _adc_data,6
	RCALL _Ssr
	RCALL SUBOPT_0x1E
; 0000 0125              Ar= (float)adc_Ar *256.0/1023;
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x16
	__PUTD1S 16
; 0000 0126           REZ = Okr(Ar);
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1D
; 0000 0127           x=10;
; 0000 0128           y=1;
	LDI  R19,LOW(1)
; 0000 0129           ps=0x41;
	RCALL SUBOPT_0x1B
; 0000 012A         }
; 0000 012B 
; 0000 012C              if  (Okr(Ar) >= ustr)   PORTD.5 = 0;       //    
_0x1C:
	RCALL SUBOPT_0x1F
	RCALL _Okr
	MOVW R26,R30
	RCALL SUBOPT_0x20
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x1F
	CBI  0x12,5
; 0000 012D 
; 0000 012E //
; 0000 012F //         if (chanel==4 && PIND.0 == 0 && PIND.2 == 0) {   //   ADC
; 0000 0130 //
; 0000 0131 //         }
; 0000 0132 //
; 0000 0133 //         if (chanel==5 && PIND.1 == 0 && PIND.3 == 0) {
; 0000 0134 //
; 0000 0135 //         }
; 0000 0136 //
; 0000 0137          ///////////////////////////////////////////////////////////////
; 0000 0138                        //   D0  D1
; 0000 0139              if (PIND.0 == 0  && button_pressed0 == 0 ){ //   1 
_0x1F:
	LDI  R26,0
	SBIC 0x10,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x23
	LDI  R26,0
	SBRC R15,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x24
_0x23:
	RJMP _0x22
_0x24:
; 0000 013A                 delay_ms(1);                             //  
	RCALL SUBOPT_0x21
; 0000 013B                 button_pressed0 = 1;                     //  
	BLD  R15,0
; 0000 013C                 //kanal=(0x4c);                            //     (L)
; 0000 013D             };
_0x22:
; 0000 013E 
; 0000 013F              if (PIND.0 == 1) button_pressed0 = 0;  //    
	SBIS 0x10,0
	RJMP _0x25
	CLT
	BLD  R15,0
; 0000 0140 
; 0000 0141 
; 0000 0142 
; 0000 0143              if (PIND.1  == 0 && button_pressed1 == 0){ //   2 
_0x25:
	LDI  R26,0
	SBIC 0x10,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x27
	LDI  R26,0
	SBRC R15,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x28
_0x27:
	RJMP _0x26
_0x28:
; 0000 0144                 delay_ms(1);                            //  
	RCALL SUBOPT_0x21
; 0000 0145                 button_pressed1 = 1;                    //  
	BLD  R15,1
; 0000 0146                 //kanal=(0x52);                           //      (R)
; 0000 0147             };
_0x26:
; 0000 0148 
; 0000 0149             if (PIND.1 == 1) button_pressed1 = 0;  //    
	SBIS 0x10,1
	RJMP _0x29
	CLT
	BLD  R15,1
; 0000 014A 
; 0000 014B           //////////
; 0000 014C                    if (PIND.0==1 && PIND.1==1) {kanal=0x80;}
_0x29:
	SBIS 0x10,0
	RJMP _0x2B
	SBIC 0x10,1
	RJMP _0x2C
_0x2B:
	RJMP _0x2A
_0x2C:
	LDI  R30,LOW(128)
	STD  Y+48,R30
; 0000 014D                          //     (L)
; 0000 014E              if (button_pressed0 == 1 && chanel==2 && (int)Al > 0){
_0x2A:
	SBRS R15,0
	RJMP _0x2E
	CPI  R17,2
	BRNE _0x2E
	RCALL SUBOPT_0x22
	BRLT _0x2F
_0x2E:
	RJMP _0x2D
_0x2F:
; 0000 014F 
; 0000 0150                 float W;
; 0000 0151 
; 0000 0152                 W = (float)(Vl*Al)/100.0;          //   Left
	SBIW R28,4
;	Ed -> Y+58
;	ps -> Y+57
;	uk -> Y+56
;	com -> Y+55
;	a -> Y+54
;	aa -> Y+53
;	kanal -> Y+52
;	ustl -> Y+50
;	ustr -> Y+48
;	c -> Y+46
;	del -> Y+44
;	REZ -> Y+40
;	vyvod -> Y+36
;	Vl -> Y+32
;	Vr -> Y+28
;	Al -> Y+24
;	Ar -> Y+20
;	adc_Vl -> Y+16
;	adc_Vr -> Y+12
;	adc_Al -> Y+8
;	adc_Ar -> Y+4
;	button_pressed0 -> R15.0
;	button_pressed1 -> R15.1
;	razr_ust_l -> R15.2
;	razr_ust_r -> R15.3
;	W -> Y+0
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x25
; 0000 0153                 REZ = Okr(W);
	RCALL SUBOPT_0x26
; 0000 0154                 ps=0x57;                             //   W
	LDI  R30,LOW(87)
	STD  Y+57,R30
; 0000 0155             }
	ADIW R28,4
; 0000 0156 
; 0000 0157 
; 0000 0158               if (button_pressed0 == 1 && chanel==3){
_0x2D:
	SBRS R15,0
	RJMP _0x31
	CPI  R17,3
	BREQ _0x32
_0x31:
	RJMP _0x30
_0x32:
; 0000 0159                   if ((int)Al > 0)
	RCALL SUBOPT_0x22
	BRGE _0x33
; 0000 015A                   {
; 0000 015B                          float om;
; 0000 015C                         kanal=(0x4c);                            //   (L)
	SBIW R28,4
;	Ed -> Y+58
;	ps -> Y+57
;	uk -> Y+56
;	com -> Y+55
;	a -> Y+54
;	aa -> Y+53
;	kanal -> Y+52
;	ustl -> Y+50
;	ustr -> Y+48
;	c -> Y+46
;	del -> Y+44
;	REZ -> Y+40
;	vyvod -> Y+36
;	Vl -> Y+32
;	Vr -> Y+28
;	Al -> Y+24
;	Ar -> Y+20
;	adc_Vl -> Y+16
;	adc_Vr -> Y+12
;	adc_Al -> Y+8
;	adc_Ar -> Y+4
;	button_pressed0 -> R15.0
;	button_pressed1 -> R15.1
;	razr_ust_l -> R15.2
;	razr_ust_r -> R15.3
;	om -> Y+0
	LDI  R30,LOW(76)
	STD  Y+52,R30
; 0000 015D                             om = (float)100.0*Vl/Al;             //  Left
	__GETD1S 32
	RCALL SUBOPT_0x27
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x23
	RCALL __DIVF21
	RCALL SUBOPT_0x1E
; 0000 015E 
; 0000 015F                            if (om>=100000){
	RCALL SUBOPT_0x28
	BRLO _0x34
; 0000 0160                               REZ = Okr(om / 1000);
	RCALL SUBOPT_0x29
; 0000 0161                               ps=0x4b;                 // kO K  
	LDI  R30,LOW(75)
	RJMP _0x7F
; 0000 0162                              }
; 0000 0163 
; 0000 0164                            else {
_0x34:
; 0000 0165                              REZ = Okr(om);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x26
; 0000 0166                              ps=0x0;                  //   
	LDI  R30,LOW(0)
_0x7F:
	STD  Y+57,R30
; 0000 0167                            }
; 0000 0168 
; 0000 0169                   }
	ADIW R28,4
; 0000 016A                   else  kanal=(0x21);         // !
	RJMP _0x36
_0x33:
	LDI  R30,LOW(33)
	STD  Y+48,R30
; 0000 016B 
; 0000 016C             }
_0x36:
; 0000 016D 
; 0000 016E 
; 0000 016F                         //      (R)
; 0000 0170              if (button_pressed1 == 1 && chanel==0 && (int)Ar > 0){
_0x30:
	SBRS R15,1
	RJMP _0x38
	CPI  R17,0
	BRNE _0x38
	RCALL SUBOPT_0x2A
	BRLT _0x39
_0x38:
	RJMP _0x37
_0x39:
; 0000 0171                   float W;
; 0000 0172 
; 0000 0173                 W = (float)(Vr*Ar)/100.0;           //   Right
	SBIW R28,4
;	Ed -> Y+58
;	ps -> Y+57
;	uk -> Y+56
;	com -> Y+55
;	a -> Y+54
;	aa -> Y+53
;	kanal -> Y+52
;	ustl -> Y+50
;	ustr -> Y+48
;	c -> Y+46
;	del -> Y+44
;	REZ -> Y+40
;	vyvod -> Y+36
;	Vl -> Y+32
;	Vr -> Y+28
;	Al -> Y+24
;	Ar -> Y+20
;	adc_Vl -> Y+16
;	adc_Vr -> Y+12
;	adc_Al -> Y+8
;	adc_Ar -> Y+4
;	button_pressed0 -> R15.0
;	button_pressed1 -> R15.1
;	razr_ust_l -> R15.2
;	razr_ust_r -> R15.3
;	W -> Y+0
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x25
; 0000 0174                 REZ = Okr(W);
	RCALL SUBOPT_0x26
; 0000 0175                 ps=0x57;                              //   W
	LDI  R30,LOW(87)
	STD  Y+57,R30
; 0000 0176 
; 0000 0177             };
	ADIW R28,4
_0x37:
; 0000 0178 
; 0000 0179 
; 0000 017A              if (button_pressed1 == 1 && chanel == 1){
	SBRS R15,1
	RJMP _0x3B
	CPI  R17,1
	BREQ _0x3C
_0x3B:
	RJMP _0x3A
_0x3C:
; 0000 017B                 if ((int)Ar > 0)
	RCALL SUBOPT_0x2A
	BRGE _0x3D
; 0000 017C                  {
; 0000 017D                     float om;
; 0000 017E                         kanal=(0x52);                    // (R)
	SBIW R28,4
;	Ed -> Y+58
;	ps -> Y+57
;	uk -> Y+56
;	com -> Y+55
;	a -> Y+54
;	aa -> Y+53
;	kanal -> Y+52
;	ustl -> Y+50
;	ustr -> Y+48
;	c -> Y+46
;	del -> Y+44
;	REZ -> Y+40
;	vyvod -> Y+36
;	Vl -> Y+32
;	Vr -> Y+28
;	Al -> Y+24
;	Ar -> Y+20
;	adc_Vl -> Y+16
;	adc_Vr -> Y+12
;	adc_Al -> Y+8
;	adc_Ar -> Y+4
;	button_pressed0 -> R15.0
;	button_pressed1 -> R15.1
;	razr_ust_l -> R15.2
;	razr_ust_r -> R15.3
;	om -> Y+0
	LDI  R30,LOW(82)
	STD  Y+52,R30
; 0000 017F                     om = (float)100.0*Vr/Ar;             //  Right
	__GETD1S 28
	RCALL SUBOPT_0x27
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x2B
	RCALL __DIVF21
	RCALL SUBOPT_0x1E
; 0000 0180 
; 0000 0181                        if (om>=100000){
	RCALL SUBOPT_0x28
	BRLO _0x3E
; 0000 0182                           REZ = Okr(om / 1000);
	RCALL SUBOPT_0x29
; 0000 0183                           ps=0x4b;                 // kO K  
	LDI  R30,LOW(75)
	RJMP _0x80
; 0000 0184                          }
; 0000 0185 
; 0000 0186                        else {
_0x3E:
; 0000 0187                          REZ = Okr(om);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x26
; 0000 0188                          ps=0x0;                  //  ( )
	LDI  R30,LOW(0)
_0x80:
	STD  Y+57,R30
; 0000 0189                        }
; 0000 018A                   }
	ADIW R28,4
; 0000 018B                   else  kanal=(0x21);            // !
	RJMP _0x40
_0x3D:
	LDI  R30,LOW(33)
	STD  Y+48,R30
; 0000 018C 
; 0000 018D             };
_0x40:
_0x3A:
; 0000 018E 
; 0000 018F 
; 0000 0190 
; 0000 0191 
; 0000 0192 
; 0000 0193            //////////////////////////////////////////////////////////////////////////
; 0000 0194            //          2.5A max
; 0000 0195 
; 0000 0196            if (PIND.2  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.3 == 1){delay_ms(20);} //   3
	RCALL SUBOPT_0x2C
	BRNE _0x42
	RCALL SUBOPT_0xF
	BRNE _0x42
	RCALL SUBOPT_0x10
	BRNE _0x42
	SBIC 0x10,3
	RJMP _0x43
_0x42:
	RJMP _0x41
_0x43:
	RCALL SUBOPT_0x2D
; 0000 0197 
; 0000 0198          if (PIND.2  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.3 == 1){
_0x41:
	RCALL SUBOPT_0x2C
	BRNE _0x45
	RCALL SUBOPT_0xF
	BRNE _0x45
	RCALL SUBOPT_0x10
	BRNE _0x45
	SBIC 0x10,3
	RJMP _0x46
_0x45:
	RJMP _0x44
_0x46:
; 0000 0199 
; 0000 019A 
; 0000 019B 
; 0000 019C              a++;
	LDD  R30,Y+50
	SUBI R30,-LOW(1)
	STD  Y+50,R30
; 0000 019D              x = 0;
	RCALL SUBOPT_0x2E
; 0000 019E              y = 1;
; 0000 019F              REZ = ustl;              //   
; 0000 01A0              ps = 0x41;
; 0000 01A1              uk = 0x3c;
	LDI  R30,LOW(60)
	STD  Y+52,R30
; 0000 01A2 
; 0000 01A3                 if (a >= 50) razr_ust_l = 1;     //   
	LDD  R26,Y+50
	CPI  R26,LOW(0x32)
	BRLO _0x47
	SET
	BLD  R15,2
; 0000 01A4          }
_0x47:
; 0000 01A5 
; 0000 01A6 
; 0000 01A7 
; 0000 01A8             if (PIND.2  == 0 && razr_ust_l == 1 && razr_ust_r == 0 && PIND.3 == 1) {
_0x44:
	RCALL SUBOPT_0x2C
	BRNE _0x49
	SBRS R15,2
	RJMP _0x49
	RCALL SUBOPT_0x10
	BRNE _0x49
	SBIC 0x10,3
	RJMP _0x4A
_0x49:
	RJMP _0x48
_0x4A:
; 0000 01A9 
; 0000 01AA 
; 0000 01AB 
; 0000 01AC              del = 300;                    //    
	RCALL SUBOPT_0x2F
; 0000 01AD              aa++;
; 0000 01AE 
; 0000 01AF                if (aa > 8) del = 50;        //    
	BRLO _0x4B
	RCALL SUBOPT_0x30
; 0000 01B0 
; 0000 01B1                                       //  
; 0000 01B2                     ++ustl;
_0x4B:
	RCALL SUBOPT_0x1C
	ADIW R30,1
	RCALL SUBOPT_0x11
; 0000 01B3 
; 0000 01B4                  if (ustl > 250) {ustl = 0;}      //   0
	RCALL SUBOPT_0xD
	CPI  R26,LOW(0xFB)
	LDI  R30,HIGH(0xFB)
	CPC  R27,R30
	BRLO _0x4C
	LDI  R30,LOW(0)
	STD  Y+46,R30
	STD  Y+46+1,R30
; 0000 01B5                      x = 0;
_0x4C:
	RCALL SUBOPT_0x2E
; 0000 01B6                      y = 1;
; 0000 01B7                      REZ = ustl;
; 0000 01B8                      ps = 0x41;
; 0000 01B9                      uk = 0xc8;                // 0x3c;
	RCALL SUBOPT_0x31
; 0000 01BA                      delay_ms(del);
; 0000 01BB 
; 0000 01BC 
; 0000 01BD             }
; 0000 01BE 
; 0000 01BF 
; 0000 01C0 
; 0000 01C1             if (PIND.3  == 0 && razr_ust_l == 1 && razr_ust_r == 0 && PIND.2 == 1) {
_0x48:
	RCALL SUBOPT_0x32
	BRNE _0x4E
	SBRS R15,2
	RJMP _0x4E
	RCALL SUBOPT_0x10
	BRNE _0x4E
	SBIC 0x10,2
	RJMP _0x4F
_0x4E:
	RJMP _0x4D
_0x4F:
; 0000 01C2 
; 0000 01C3              del = 300;
	RCALL SUBOPT_0x2F
; 0000 01C4              aa++;
; 0000 01C5 
; 0000 01C6                if (aa > 8) del = 50;
	BRLO _0x50
	RCALL SUBOPT_0x30
; 0000 01C7 
; 0000 01C8                   if (ustl > 0){      //   
_0x50:
	RCALL SUBOPT_0xD
	RCALL __CPW02
	BRSH _0x51
; 0000 01C9 
; 0000 01CA                    --ustl;             //  
	RCALL SUBOPT_0x1C
	SBIW R30,1
	RCALL SUBOPT_0x11
; 0000 01CB 
; 0000 01CC                   if (ustl <= 0) {ustl=250;}
	RCALL SUBOPT_0xD
	SBIW R26,0
	BRNE _0x52
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	RCALL SUBOPT_0x11
; 0000 01CD                      x = 0;
_0x52:
	RCALL SUBOPT_0x2E
; 0000 01CE                      y = 1;
; 0000 01CF                      REZ = ustl;
; 0000 01D0                      ps = 0x41;
; 0000 01D1                      uk = 0xc8;                 //      0x3c;
	RCALL SUBOPT_0x31
; 0000 01D2                      delay_ms(del);
; 0000 01D3                 }
; 0000 01D4 
; 0000 01D5             }
_0x51:
; 0000 01D6 
; 0000 01D7 
; 0000 01D8             //////////////////////////////////////////////////////////////////////////
; 0000 01D9 
; 0000 01DA             //////////////////////////////////////////////////////////////////////////
; 0000 01DB             ///         2.5A max
; 0000 01DC 
; 0000 01DD            if (PIND.3  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.2 == 1){delay_ms(20);} //   3
_0x4D:
	RCALL SUBOPT_0x32
	BRNE _0x54
	RCALL SUBOPT_0xF
	BRNE _0x54
	RCALL SUBOPT_0x10
	BRNE _0x54
	SBIC 0x10,2
	RJMP _0x55
_0x54:
	RJMP _0x53
_0x55:
	RCALL SUBOPT_0x2D
; 0000 01DE 
; 0000 01DF          if (PIND.3  == 0 && razr_ust_l == 0 && razr_ust_r == 0 && PIND.2 == 1){
_0x53:
	RCALL SUBOPT_0x32
	BRNE _0x57
	RCALL SUBOPT_0xF
	BRNE _0x57
	RCALL SUBOPT_0x10
	BRNE _0x57
	SBIC 0x10,2
	RJMP _0x58
_0x57:
	RJMP _0x56
_0x58:
; 0000 01E0 
; 0000 01E1              a++;
	LDD  R30,Y+50
	SUBI R30,-LOW(1)
	STD  Y+50,R30
; 0000 01E2              x=10;
	RCALL SUBOPT_0x33
; 0000 01E3              y=1;
; 0000 01E4              REZ=ustr;              //   
; 0000 01E5              ps=0x41;
; 0000 01E6              uk=0x3e;
	LDI  R30,LOW(62)
	STD  Y+52,R30
; 0000 01E7 
; 0000 01E8                 if (a >= 50)  razr_ust_r = 1;     //   
	LDD  R26,Y+50
	CPI  R26,LOW(0x32)
	BRLO _0x59
	SET
	BLD  R15,3
; 0000 01E9          }
_0x59:
; 0000 01EA 
; 0000 01EB 
; 0000 01EC 
; 0000 01ED             if (PIND.3  == 0 && razr_ust_l == 0 && razr_ust_r == 1 && PIND.2 == 1) {
_0x56:
	RCALL SUBOPT_0x32
	BRNE _0x5B
	RCALL SUBOPT_0xF
	BRNE _0x5B
	SBRS R15,3
	RJMP _0x5B
	SBIC 0x10,2
	RJMP _0x5C
_0x5B:
	RJMP _0x5A
_0x5C:
; 0000 01EE 
; 0000 01EF              del = 300;
	RCALL SUBOPT_0x34
; 0000 01F0              aa++;
; 0000 01F1 
; 0000 01F2                if (aa > 10) del = 50;
	BRLO _0x5D
	RCALL SUBOPT_0x30
; 0000 01F3 
; 0000 01F4              ++ustr;                         //  
_0x5D:
	RCALL SUBOPT_0x20
	ADIW R30,1
	RCALL SUBOPT_0x14
; 0000 01F5 
; 0000 01F6                  if (ustr>250) {ustr=0;}
	RCALL SUBOPT_0x13
	CPI  R26,LOW(0xFB)
	LDI  R30,HIGH(0xFB)
	CPC  R27,R30
	BRLO _0x5E
	LDI  R30,LOW(0)
	STD  Y+44,R30
	STD  Y+44+1,R30
; 0000 01F7                      x = 10;
_0x5E:
	RCALL SUBOPT_0x33
; 0000 01F8                      y = 1;
; 0000 01F9                      REZ = ustr;
; 0000 01FA                      ps = 0x41;
; 0000 01FB                      uk = 0xc9;             //   0x3e;
	RCALL SUBOPT_0x35
; 0000 01FC                      delay_ms(del);
; 0000 01FD 
; 0000 01FE 
; 0000 01FF             }
; 0000 0200 
; 0000 0201 
; 0000 0202 
; 0000 0203             if (PIND.2  == 0 && razr_ust_l == 0 && razr_ust_r == 1 && PIND.3 == 1) {
_0x5A:
	RCALL SUBOPT_0x2C
	BRNE _0x60
	RCALL SUBOPT_0xF
	BRNE _0x60
	SBRS R15,3
	RJMP _0x60
	SBIC 0x10,3
	RJMP _0x61
_0x60:
	RJMP _0x5F
_0x61:
; 0000 0204 
; 0000 0205              del = 300;
	RCALL SUBOPT_0x34
; 0000 0206              aa++;
; 0000 0207 
; 0000 0208                if (aa > 10) del = 50;
	BRLO _0x62
	RCALL SUBOPT_0x30
; 0000 0209 
; 0000 020A                   if (ustr > 0){                     //   
_0x62:
	RCALL SUBOPT_0x13
	RCALL __CPW02
	BRSH _0x63
; 0000 020B 
; 0000 020C                      --ustr;                         //  
	RCALL SUBOPT_0x20
	SBIW R30,1
	RCALL SUBOPT_0x14
; 0000 020D 
; 0000 020E                   if (ustr <= 0) {ustr=250;}
	RCALL SUBOPT_0x13
	SBIW R26,0
	BRNE _0x64
	LDI  R30,LOW(250)
	LDI  R31,HIGH(250)
	RCALL SUBOPT_0x14
; 0000 020F                      x = 10;
_0x64:
	RCALL SUBOPT_0x33
; 0000 0210                      y = 1;
; 0000 0211                      REZ = ustr;
; 0000 0212                      ps = 0x41;
; 0000 0213                      uk = 0xc9;                     //  0x3e;
	RCALL SUBOPT_0x35
; 0000 0214                      delay_ms(del);
; 0000 0215                 }
; 0000 0216 
; 0000 0217             }
_0x63:
; 0000 0218                //   <  >   
; 0000 0219 
; 0000 021A         if (PIND.3 == 1 && PIND.2  == 1 && razr_ust_l == 0 && razr_ust_r == 0)  uk = 0x80;
_0x5F:
	SBIS 0x10,3
	RJMP _0x66
	SBIS 0x10,2
	RJMP _0x66
	RCALL SUBOPT_0xF
	BRNE _0x66
	RCALL SUBOPT_0x10
	BREQ _0x67
_0x66:
	RJMP _0x65
_0x67:
	LDI  R30,LOW(128)
	STD  Y+52,R30
; 0000 021B 
; 0000 021C         if (PIND.3 == 1 && PIND.2  == 1)  a = 0; //   
_0x65:
	SBIS 0x10,3
	RJMP _0x69
	SBIC 0x10,2
	RJMP _0x6A
_0x69:
	RJMP _0x68
_0x6A:
	LDI  R30,LOW(0)
	STD  Y+50,R30
; 0000 021D 
; 0000 021E          //////////////////////////////////////////////////////////////////////////
; 0000 021F 
; 0000 0220                        //        
; 0000 0221 
; 0000 0222               if (PIND.2==1 && PIND.3==1 && (razr_ust_l == 1 | razr_ust_r == 1)) aa = 0;
_0x68:
	SBIS 0x10,2
	RJMP _0x6C
	SBIS 0x10,3
	RJMP _0x6C
	LDI  R26,0
	SBRC R15,2
	LDI  R26,1
	LDI  R30,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	LDI  R26,0
	SBRC R15,3
	LDI  R26,1
	LDI  R30,LOW(1)
	RCALL __EQB12
	OR   R30,R0
	BRNE _0x6D
_0x6C:
	RJMP _0x6B
_0x6D:
	LDI  R30,LOW(0)
	STD  Y+49,R30
; 0000 0223 
; 0000 0224              //           3  4
; 0000 0225 
; 0000 0226                  if (PIND.2==0 || PIND.3==0) c = 0;  //     
_0x6B:
	RCALL SUBOPT_0x2C
	BREQ _0x6F
	RCALL SUBOPT_0x32
	BRNE _0x6E
_0x6F:
	LDI  R30,LOW(0)
	STD  Y+42,R30
	STD  Y+42+1,R30
; 0000 0227                                                      // 
; 0000 0228                c++;                   // 
_0x6E:
	LDD  R30,Y+42
	LDD  R31,Y+42+1
	ADIW R30,1
	STD  Y+42,R30
	STD  Y+42+1,R31
; 0000 0229 
; 0000 022A                 if (c >= 300)         //  
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	CPI  R26,LOW(0x12C)
	LDI  R30,HIGH(0x12C)
	CPC  R27,R30
	BRLO _0x71
; 0000 022B                 {
; 0000 022C                    uk = 0x80;         //   <  >
	LDI  R30,LOW(128)
	STD  Y+52,R30
; 0000 022D                    razr_ust_l = 0;    //   
	CLT
	BLD  R15,2
; 0000 022E                    razr_ust_r = 0;    //   
	BLD  R15,3
; 0000 022F 
; 0000 0230                    if (e_ustl != ustl)  e_ustl = ustl;    //     EEPROM
	RCALL SUBOPT_0xC
	MOVW R26,R30
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0xE
	BREQ _0x72
	RCALL SUBOPT_0x1C
	LDI  R26,LOW(_e_ustl)
	LDI  R27,HIGH(_e_ustl)
	RCALL __EEPROMWRW
; 0000 0231                    if (e_ustr != ustr)  e_ustr = ustr;    //    EEPROM
_0x72:
	RCALL SUBOPT_0x12
	MOVW R26,R30
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0xE
	BREQ _0x73
	RCALL SUBOPT_0x20
	LDI  R26,LOW(_e_ustr)
	LDI  R27,HIGH(_e_ustr)
	RCALL __EEPROMWRW
; 0000 0232 
; 0000 0233                    c = 0;
_0x73:
	LDI  R30,LOW(0)
	STD  Y+42,R30
	STD  Y+42+1,R30
; 0000 0234                 }
; 0000 0235 
; 0000 0236 
; 0000 0237        /////////////////////////////////////////////////////////////////////////////////
; 0000 0238 
; 0000 0239 
; 0000 023A        //----------------    
; 0000 023B           if (REZ>9999) {
_0x71:
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	BRLO _0x74
; 0000 023C           vyvod=REZ/10;       // /10
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x38
	RCALL __DIVD21U
	RCALL SUBOPT_0x39
; 0000 023D           com=1;
	LDI  R30,LOW(1)
	STD  Y+51,R30
; 0000 023E           }
; 0000 023F 
; 0000 0240           if (REZ<10000 && REZ>99){
_0x74:
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	BRSH _0x76
	RCALL SUBOPT_0x3A
	BRSH _0x77
_0x76:
	RJMP _0x75
_0x77:
; 0000 0241           vyvod=REZ;
	RCALL SUBOPT_0x3B
; 0000 0242           com=2;
; 0000 0243           }
; 0000 0244 
; 0000 0245           if (REZ<100) {
_0x75:
	RCALL SUBOPT_0x3A
	BRSH _0x78
; 0000 0246           vyvod=REZ;
	RCALL SUBOPT_0x3B
; 0000 0247           com=2;
; 0000 0248           }
; 0000 0249 
; 0000 024A 
; 0000 024B 
; 0000 024C             Ts=(vyvod/1000)%10;     //  
_0x78:
	RCALL SUBOPT_0x24
	__GETD1N 0x3E8
	RCALL SUBOPT_0x3C
	MOV  R18,R30
; 0000 024D 
; 0000 024E             St=(vyvod/100)%10;      //  
	RCALL SUBOPT_0x24
	__GETD1N 0x64
	RCALL SUBOPT_0x3C
	MOV  R21,R30
; 0000 024F 
; 0000 0250             Ds=(vyvod/10)%10;       //  
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x3C
	MOV  R20,R30
; 0000 0251 
; 0000 0252             Ed=(vyvod/1)%10;        //  
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x38
	RCALL __MODD21U
	STD  Y+54,R30
; 0000 0253 
; 0000 0254        //-----------------   LCD
; 0000 0255 
; 0000 0256                 lcd_gotoxy(x,y);
	ST   -Y,R16
	MOV  R26,R19
	RCALL _lcd_gotoxy
; 0000 0257 
; 0000 0258        if (REZ>9999 )   lcd_putchar(0x80);     //   
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	BRLO _0x79
	LDI  R26,LOW(128)
	RCALL _lcd_putchar
; 0000 0259        if (REZ >=1000)  lcd_putchar(Ts+0x30);
_0x79:
	RCALL SUBOPT_0x3D
	BRLO _0x7A
	MOV  R26,R18
	RCALL SUBOPT_0x3E
; 0000 025A                         lcd_putchar(St+0x30);
_0x7A:
	MOV  R26,R21
	RCALL SUBOPT_0x3E
; 0000 025B        if (REZ<9999 )   lcd_putchar(',');
	RCALL SUBOPT_0x36
	__CPD2N 0x270F
	BRSH _0x7B
	LDI  R26,LOW(44)
	RCALL _lcd_putchar
; 0000 025C                         lcd_putchar(Ds+0x30);
_0x7B:
	MOV  R26,R20
	RCALL SUBOPT_0x3E
; 0000 025D        if (REZ < 1000)  lcd_putchar(Ed+0x30);
	RCALL SUBOPT_0x3D
	BRSH _0x7C
	LDD  R26,Y+54
	RCALL SUBOPT_0x3E
; 0000 025E                         lcd_putchar(ps);
_0x7C:
	LDD  R26,Y+53
	RCALL _lcd_putchar
; 0000 025F 
; 0000 0260                 lcd_gotoxy(7,1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
; 0000 0261             lcd_putchar(uk);
	LDD  R26,Y+52
	RCALL _lcd_putchar
; 0000 0262                 lcd_gotoxy(7,0);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _lcd_gotoxy
; 0000 0263             lcd_putchar(kanal);
	LDD  R26,Y+48
	RCALL _lcd_putchar
; 0000 0264             delay_ms(10);
	LDI  R26,LOW(10)
	RCALL SUBOPT_0x3F
; 0000 0265 
; 0000 0266              com=0;
	LDI  R30,LOW(0)
	STD  Y+51,R30
; 0000 0267 
; 0000 0268      }     //while(1)
	RJMP _0xA
; 0000 0269 
; 0000 026A }    //main
_0x7D:
	RJMP _0x7D
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	ST   -Y,R26
	IN   R30,0x18
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LD   R30,Y
	ANDI R30,LOW(0xF0)
	OR   R30,R26
	OUT  0x18,R30
	__DELAY_USB 3
	SBI  0x18,2
	__DELAY_USB 7
	CBI  0x18,2
	__DELAY_USB 7
	RJMP _0x2020001
__lcd_write_data:
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 67
	RJMP _0x2020001
_lcd_write_byte:
	ST   -Y,R26
	LDD  R26,Y+1
	RCALL __lcd_write_data
	RCALL SUBOPT_0x40
	RJMP _0x2020002
_lcd_gotoxy:
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R5,Y+1
	LDD  R4,Y+0
_0x2020002:
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R26,LOW(2)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	RCALL SUBOPT_0x3F
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	RCALL __lcd_write_data
	LDI  R26,LOW(3)
	RCALL SUBOPT_0x3F
	LDI  R30,LOW(0)
	MOV  R4,R30
	MOV  R5,R30
	RET
_lcd_putchar:
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000005
	CP   R5,R7
	BRLO _0x2000004
_0x2000005:
	LDI  R30,LOW(0)
	ST   -Y,R30
	INC  R4
	MOV  R26,R4
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020001
_0x2000004:
	INC  R5
	RCALL SUBOPT_0x40
	RJMP _0x2020001
_lcd_init:
	ST   -Y,R26
	IN   R30,0x17
	ORI  R30,LOW(0xF0)
	OUT  0x17,R30
	SBI  0x17,2
	SBI  0x17,0
	SBI  0x17,1
	CBI  0x18,2
	CBI  0x18,0
	CBI  0x18,1
	LDD  R7,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x41
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 133
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x2020001:
	ADIW R28,1
	RET

	.DSEG
_adc_data:
	.BYTE 0xC
_input_index_S0000003000:
	.BYTE 0x1

	.ESEG
_e_ustl:
	.BYTE 0x2
_e_ustr:
	.BYTE 0x2

	.DSEG
__base_y_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x0:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2:
	RCALL __CWD1
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x3:
	RCALL __PUTD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x4:
	RCALL __GETD2S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x6:
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	LDI  R26,LOW(_e_ustl)
	LDI  R27,HIGH(_e_ustl)
	RCALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDD  R26,Y+46
	LDD  R27,Y+46+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0xF:
	LDI  R26,0
	SBRC R15,2
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x10:
	LDI  R26,0
	SBRC R15,3
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	STD  Y+46,R30
	STD  Y+46+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	LDI  R26,LOW(_e_ustr)
	LDI  R27,HIGH(_e_ustr)
	RCALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	STD  Y+44,R30
	STD  Y+44+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x15:
	__GETD1N 0x3F800000
	RCALL __MULF12
	__GETD2N 0x45200000
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x16:
	__GETD1N 0x447FC000
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	__GETD2S 28
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	RCALL _Okr
	RCALL __CWD1
	__PUTD1S 36
	LDI  R16,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	__GETD1N 0x43800000
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	__GETD2S 20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(65)
	STD  Y+53,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1C:
	LDD  R30,Y+46
	LDD  R31,Y+46+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1D:
	RCALL _Okr
	RCALL __CWD1
	__PUTD1S 36
	LDI  R16,LOW(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	RCALL SUBOPT_0x3
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	__GETD2S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x20:
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x21:
	LDI  R26,LOW(1)
	LDI  R27,0
	RCALL _delay_ms
	SET
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x22:
	__GETD1S 20
	RCALL __CFD1
	MOVW R26,R30
	RCALL __CPW02
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	__GETD1S 24
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x24:
	__GETD2S 32
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x25:
	__GETD1N 0x42C80000
	RCALL __DIVF21
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x26:
	RCALL _Okr
	RCALL __CWD1
	__PUTD1S 40
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x27:
	__GETD2N 0x42C80000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x28:
	__GETD1N 0x47C35000
	RCALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x29:
	RCALL SUBOPT_0x4
	__GETD1N 0x447A0000
	RCALL __DIVF21
	RCALL SUBOPT_0x7
	RJMP SUBOPT_0x26

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2A:
	__GETD1S 16
	RCALL __CFD1
	MOVW R26,R30
	RCALL __CPW02
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	__GETD1S 20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2C:
	LDI  R26,0
	SBIC 0x10,2
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2D:
	LDI  R26,LOW(20)
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2E:
	LDI  R16,LOW(0)
	LDI  R19,LOW(1)
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x5
	__PUTD1S 36
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2F:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	STD  Y+40,R30
	STD  Y+40+1,R31
	LDD  R30,Y+49
	SUBI R30,-LOW(1)
	STD  Y+49,R30
	LDD  R26,Y+49
	CPI  R26,LOW(0x9)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x30:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	STD  Y+40,R30
	STD  Y+40+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x31:
	LDI  R30,LOW(200)
	STD  Y+52,R30
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x32:
	LDI  R26,0
	SBIC 0x10,3
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x33:
	LDI  R16,LOW(10)
	LDI  R19,LOW(1)
	RCALL SUBOPT_0x20
	RCALL SUBOPT_0x5
	__PUTD1S 36
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x34:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	STD  Y+40,R30
	STD  Y+40+1,R31
	LDD  R30,Y+49
	SUBI R30,-LOW(1)
	STD  Y+49,R30
	LDD  R26,Y+49
	CPI  R26,LOW(0xB)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x35:
	LDI  R30,LOW(201)
	STD  Y+52,R30
	LDD  R26,Y+40
	LDD  R27,Y+40+1
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x36:
	__GETD2S 36
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x37:
	__CPD2N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x38:
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x39:
	__PUTD1S 32
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3A:
	RCALL SUBOPT_0x36
	__CPD2N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3B:
	__GETD1S 36
	RCALL SUBOPT_0x39
	LDI  R30,LOW(2)
	STD  Y+51,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3C:
	RCALL __DIVD21U
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x38
	RCALL __MODD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3D:
	RCALL SUBOPT_0x36
	__CPD2N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3E:
	SUBI R26,-LOW(48)
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3F:
	LDI  R27,0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	SBI  0x18,0
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x18,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x41:
	LDI  R26,LOW(48)
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 133
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
